=== debian/changelog ===
openvas-scanner (23.30.1-1) unstable; urgency=medium

  * New upstream version 23.30.1
  * Refresh patches
  * Update debian/watch to Version 5
  * Update build-dep: add libmagic-dev
  * Update debian/copyright
  * Add dep on gpg-agent

 -- Sophie Brun <sophie@kali.org>  Thu, 13 Nov 2025 09:23:54 +0100
