=== debian/watch ===
Version: 5
Template: Github
Owner: greenbone
Project: openvas-scanner
