=== debian/changelog ===
openvas-scanner (23.32.5-1) unstable; urgency=medium

  * New upstream version 23.32.5
  * Refresh patches

 -- Sophie Brun <sophie@kali.org>  Fri, 05 Dec 2025 11:23:55 +0100
