=== debian/changelog ===
openvas-scanner (23.32.6-1) unstable; urgency=medium

  * New upstream version 23.32.6
  * Refresh patches

 -- Sophie Brun <sophie@kali.org>  Mon, 08 Dec 2025 14:10:33 +0100
