## openvas-scanner 23.35.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -8,7 +8,7 @@
 
 # VERSION: Always include major, minor and patch level.
 project (openvas
-  VERSION 23.32.6
+  VERSION 23.35.3
   LANGUAGES C)
 
 if (POLICY CMP0005)
