=== debian/changelog ===
openvas-scanner (23.35.3-1parrot1) echo; urgency=medium

  * Import new Debian testing version.

 -- Lorenzo "Palinuro" Faletra <palinuro@parrotsec.org>  Thu, 18 Dec 2025 18:59:19 +0100

openvas-scanner (23.35.3-1) unstable; urgency=medium

  * New upstream version 23.35.3
  * Refresh patches

 -- Sophie Brun <sophie@kali.org>  Wed, 17 Dec 2025 09:27:55 +0100
