=== debian/changelog ===
openvas-scanner (23.35.4-1) unstable; urgency=medium

  * New upstream version 23.35.4
  * Refresh patches

 -- Sophie Brun <sophie@kali.org>  Thu, 08 Jan 2026 11:34:31 +0100
