## openvas-scanner 23.36.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -8,7 +8,7 @@
 
 # VERSION: Always include major, minor and patch level.
 project (openvas
-  VERSION 23.35.4
+  VERSION 23.36.1
   LANGUAGES C)
 
 if (POLICY CMP0005)
