=== debian/changelog ===
openvas-scanner (23.36.1-1) unstable; urgency=medium

  * New upstream version 23.36.1
  * Refresh patches

 -- Sophie Brun <sophie@kali.org>  Thu, 15 Jan 2026 11:31:19 +0100
