=== rust/examples/container_image_scanning/local-registry/Makefile ===
--- 
+++ 
@@ -5,13 +5,29 @@
 
 .DEFAULT_GOAL := start
 
+CONTAINER := $(shell command -v docker 2>/dev/null || command -v podman)
+
+ifeq ($(CONTAINER),docker)
+    PULL_CMD := $(CONTAINER) pull
+else
+    PULL_CMD := $(CONTAINER) pull --tls-verify=false
+endif
+
+ifeq ($(CONTAINER),docker)
+    PUSH_CMD := $(CONTAINER) push
+else
+    PUSH_CMD := $(CONTAINER) push --tls-verify=false
+endif
+
+
+
 # Parameter:
 # 1: the name of the container to start
 # 2: the make command to execute if container name was not found
 define start_container
-@if docker ps -a --format '{{.Names}}' | grep -wq $(1); then \
+@if $(CONTAINER) ps -a --format '{{.Names}}' | grep -wq $(1); then \
 	echo "Starting existing container: $(1)"; \
-	docker start $(1); \
+	$(CONTAINER) start $(1); \
 else \
 	echo "Container $(1) not found. Running: $(2)"; \
 	$(MAKE) $(2); \
@@ -26,7 +42,7 @@
 	@while IFS= read -r image; do \
 		if [ -n "$$image" ]; then \
 			echo "removing $$image"; \
-			docker rmi $$image 2> /dev/null || true ; \
+			$(CONTAINER) rmi $$image 2> /dev/null || true ; \
 		fi \
 	done < $(IMAGES_FILE)
 
@@ -35,15 +51,15 @@
 	@echo "Begin mirroring images to $(LOCAL_REGISTRY)."
 	@while IFS= read -r image; do \
 		if [ -n "$$image" ]; then \
-			echo "docker pull $$image"; \
-			docker pull $$image > /dev/null 2>&1; \
+			echo "$(PULL_CMD) $$image"; \
+			$(PULL_CMD) $$image > /dev/null 2>&1; \
 			repo_tag=$$(echo $$image | sed 's|.*/||'); \
 			local_tag=$(LOCAL_REGISTRY)/$$image; \
-			echo "docker tag $$image $$local_tag"; \
-			docker tag $$image $$local_tag > /dev/null 2>&1; \
-			echo "docker push $$local_tag"; \
-			docker push $$local_tag > /dev/null 2>&1; \
-			docker rmi $$local_tag > /dev/null 2>&1; \
+			echo "$(CONTAINER) tag $$image $$local_tag"; \
+			$(CONTAINER) tag $$image $$local_tag > /dev/null 2>&1; \
+			echo "$(PUSH_CMD) $$local_tag"; \
+			$(PUSH_CMD) $$local_tag > /dev/null 2>&1; \
+			$(CONTAINER) rmi $$local_tag > /dev/null 2>&1; \
 		fi \
 	done < $(IMAGES_FILE)
 	@echo "End $(LOCAL_REGISTRY)."
@@ -55,7 +71,7 @@
 	  -subj "/CN=localhost"
 
 auth-server:
-	docker run -d \
+	$(CONTAINER) run -d \
 		--name auth_server \
 		-p 5001:5001 \
 		-v "$(BASE_PATH)/config:/config" \
@@ -64,16 +80,16 @@
 		cesanta/docker_auth
 
 stop-auth-server:
-	docker stop auth_server
+	$(CONTAINER) stop auth_server
 
 start-auth-server:
 	$(call start_container,auth_server,auth-server)
 
 rm-auth-server: stop-auth-server
-	docker rm auth_server
+	$(CONTAINER) rm auth_server
 
 docker-registry: 
-	docker run -d \
+	$(CONTAINER) run -d \
 		--name registry \
 		-p 5000:5000 \
 		-v "$(BASE_PATH)/certs:/certs" \
@@ -87,7 +103,7 @@
 		registry:2
 
 stop-docker-registry:
-	docker stop registry
+	$(CONTAINER) stop registry
 
 start-docker-registry:
 	$(call start_container,registry,docker-registry)
@@ -99,6 +115,6 @@
 start-mirror: start mirror-images
 
 rm-docker-registry: stop-docker-registry
-	docker rm registry
+	$(CONTAINER) rm registry
 
 rm: rm-docker-registry rm-auth-server
