=== debian/changelog ===
openvas-scanner (23.38.0-1) unstable; urgency=medium

  * New upstream version 23.38.0
  * Refresh patches

 -- Sophie Brun <sophie@kali.org>  Wed, 21 Jan 2026 12:01:26 +0100
