=== debian/changelog ===
openvas-scanner (23.38.1-1build1) resolute; urgency=medium

  * No-change rebuild for gpgme1.0 2.0

 -- Ural Tunaboyu <ural.tunaboyu@canonical.com>  Sat, 21 Feb 2026 14:34:28 +0000

openvas-scanner (23.38.1-1) unstable; urgency=medium

  * New upstream version 23.38.1
  * Refresh patches

 -- Sophie Brun <sophie@kali.org>  Thu, 29 Jan 2026 15:25:09 +0100
