=== debian/changelog ===
openvas-scanner (23.40.2-1) unstable; urgency=medium

  * New upstream version 23.40.2
  * Refresh patches
  * Fix build on 32 bit arch

 -- Sophie Brun <sophie@kali.org>  Wed, 25 Feb 2026 15:05:17 +0100
